//+------------------------------------------------------------------+
//|                                             HISTO HULL ALARM.mq4 |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ 

///|  MODIFIED BY SOHOCOOL TO DO HULL HISTO ALARM 2012
//+------------------------------------------------------------------+
#property copyright "OPEN SOURCE"
#property link      "http://www.metaquotes.net/"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 LawnGreen
#property indicator_color2 Red
#property  indicator_width1  3
#property  indicator_width2  3

#property indicator_minimum 0
#property indicator_maximum 1

//#property indicator_color3 LightSeaGreen
//---- indicator parameters
extern int    BandsPeriod=18;
extern int PRICE =5;
extern int   MODE_Band =3;
extern int    BandsShift=0;
//extern double BandsDeviations=0.33;/
//////////////////////////////////////////
extern string note            = "turn on Alert = true; turn off = false";
extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = true;
extern bool   alertsEmail     = false;
extern string soundfile       = "alert2.wav";
///////////////////////////////////////////////////////////

//---- buffers
double MovingBuffer[];
//double UpperBuffer[];
//double LowerBuffer[];
double SignalBuffer[];
double trend[];
double hmahu[], hmahd[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorBuffers(5);
SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(0,hmahu);
   
   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(1,hmahd);

   //SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(2,MovingBuffer);
   //SetIndexStyle(1,DRAW_LINE);
   ///SetIndexBuffer(1,UpperBuffer);
   //SetIndexStyle(2,DRAW_LINE);
   //SetIndexBuffer(2,LowerBuffer);
//----
  // SetIndexDrawBegin(0,BandsPeriod+BandsShift);
   //SetIndexDrawBegin(1,BandsPeriod+BandsShift);
  // SetIndexDrawBegin(2,BandsPeriod+BandsShift);
   
   SetIndexBuffer(3,SignalBuffer);
   SetIndexBuffer(4,trend);
   
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Bollinger Bands                                                  |
//+------------------------------------------------------------------+
int start()
  {
   int    i,k,counted_bars=IndicatorCounted();
   double deviation;
   double sum,oldval,newres;
//----
   if(Bars<=BandsPeriod) return(0);
//---- initial zero
   if(counted_bars<1)
      for(i=1;i<=BandsPeriod;i++)
        {
         MovingBuffer[Bars-i]=EMPTY_VALUE;
        // UpperBuffer[Bars-i]=EMPTY_VALUE;
        // LowerBuffer[Bars-i]=EMPTY_VALUE;
        }
//----
   int limit=Bars-counted_bars;
   if(counted_bars>0) limit++;
   for(i=0; i<limit; i++)
      SignalBuffer[i]= iMA(NULL,0,MathFloor(BandsPeriod/2),BandsShift,MODE_Band,PRICE,i)*2-iMA(NULL,0,BandsPeriod,BandsShift,MODE_Band,PRICE,i);
    for(i=0; i<limit; i++)  
    
    
      MovingBuffer[i]=iMAOnArray(SignalBuffer,Bars,MathFloor(MathSqrt(BandsPeriod)),BandsShift,MODE_Band,i);
///////////////////////////////////////////////////////
 for(i=0; i<limit; i++)  
    
{ trend[i] = trend[i+1];
 
 //for(i=0; i<limit; i++)  
    
            if (MovingBuffer[i]>MovingBuffer[i+1]) trend[i] =  1;
            if (MovingBuffer[i]<MovingBuffer[i+1]) trend[i] = -1;
            
            
            if (trend[i]==  1) { hmahu[i] = 1; hmahd[i] = EMPTY_VALUE; }               
            if (trend[i]== -1) { hmahd[i] = 1; hmahu[i] = EMPTY_VALUE; }  

}
/////////////////////////////////
  if (alertsOn)
       {
       if (alertsOnCurrent)
            int whichBar = 0;
       else     whichBar = 1;

       //
       //
       //
       //
       //
         
       if (trend[whichBar] != trend[whichBar+1])
       if (trend[whichBar] == 1)
             doAlert("_Buy");
       else  doAlert("_Sell");       
   }

////////////////////////////////////
   return(0);
  }
//+------------------------------------------------------------------+

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Hull Histo",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Hull Histo "),message);
             if (alertsSound)   PlaySound(soundfile);
      }
}